// Határozzuk meg az n elemû bemeneti tömb legnagyobb értékét!

#include <iostream>
#include <fstream>

using namespace std;

int const maxDim = 101;

ifstream fin("adatok.in");

void beOlvas(int & n, int x[]){

	fin >> n; 
	for(int i = 1; i <= n; i++)
		fin >> x[i];	
}

void kiir(int n, int x[]){

	cout << "n = " << n << endl;
	for(int i = 1; i <= n; i++)
		cout << x[i] << " ";	
	cout << endl;
}

int maximumKivalasztas(int n, int x[]){
// iteratív implementáció
	
	int max = x[1];
	
	for(int i = 2; i <= n; i++)
		if(max < x[i])
			max = x[i];
	
	return max;
}

int maximumKivalasztasRek(int n, int x[]){
// rekurzív implementáció

	if(n == 1)
		return x[1];
	else
		if(x[n] > maximumKivalasztasRek(n - 1, x))
			return x[n];
		else
			return maximumKivalasztasRek(n - 1, x);// a következő elem a sorozatból
}

int main(){
	int n;
	int x[maxDim];
	
	beOlvas(n, x);
	kiir(n, x);
	cout << "Iterativan: " << endl;
	cout << "A tomb maximuma = " << maximumKivalasztas(n, x) << endl;	
	cout << "Rekurzivan: " << endl;
	cout << "A tomb maximuma = " << maximumKivalasztasRek(n, x) << endl;	
}
