// Buborkrendezs az els csere helytl az utols csere helyig

#include <iostream>

using namespace std;

void kiir(int n, int x[]){
	for(int i = 1; i <= n; i++)
		cout << x[i] << " ";
	cout << endl;
}

void csere(int & a, int & b){
	a ^= b ^= a ^= b;	
}

void javitottBuborekRendezes3(int n, int x[]){
	bool rendezett;
	int regiJobb = n - 1;
	int regiBal = 1;
	int jobb;
	int bal;

	do{
		rendezett = true;

		for(int i = regiBal; i <= regiJobb; i++){
			if(x[i] > x[i + 1]){
				csere(x[i], x[i + 1]);
				rendezett = false;
				jobb = i - 1;
			}
		}

		if(!rendezett){
			regiJobb = jobb;
			rendezett = true;

			for(int i = regiJobb; i >= regiBal; i--){
				if(x[i] > x[i + 1]){
					csere(x[i], x[i + 1]);
					rendezett = false;
					bal = i + 1;
				}
			}

			regiBal = bal;
		}

	}while(!rendezett);
}

int main(){
	cout <<" - Javitott Bubble Sort 3 - \n\n";

	int x[] = {0, 13, 5, 1, 45, 21, 100, 6, 321, 11, 4, 12};
	int n = 11;

	cout << "A sorozat: " << endl;
	kiir(n, x);
	cout << endl;
	
	javitottBuborekRendezes3(n, x);

	cout << "Rendezve: " << endl;
	kiir(n, x);
	cout << endl;
}
